# This file is a template, and might need editing before it works on your project.
# use the official gcc image, based on debian
# can use verions as well, like gcc:5.2
# see https://hub.docker.com/_/gcc/
stages:
  - build
  - test

image: alpine
variables:
    BUILD_TYPE: Debug

default:
  before_script:
    - apk add cmake && apk add gcc && apk add g++ && apk add make

build:
  stage: build
  # instead of calling g++ directly you can also use some build toolkit like make
  # install the necessary build tools when needed
  # before_script:
  #    - apk add cmake && apk add gcc && apk add g++ && apk add make
  script:
    - cmake -B $CI_PROJECT_DIR/build -DCMAKE_BUILD_TYPE=$BUILD_TYPE
    - cmake --build $CI_PROJECT_DIR/build --config $BUILD_TYPE
  artifacts:
    paths:
      - build/

# run tests using the binary built before
test:
  stage: test
  
  script:
    - cd $CI_PROJECT_DIR/build
    - ctest -C $BUILD_TYPE
  dependencies:
    - build